routes/web.php
<?php


use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\RoleController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/*
 *
 */
Route::redirect('/', '/welcome');
Route::view('/welcome', 'welcome');
Route::view('/home', 'home')->middleware('auth')->name('home');

/*
 * User CRUD routes group
 */
Route::resource('users', UserController::class)->except('show');
Route::get('users/{user}/delete', [UserController::class, 'delete'])->name('users.delete');
Route::get('users/{user}/activity', [UserController::class, 'activity'])->name('users.activity');

/*
 * Uses profile routing group
 */
Route::get('profile', [ProfileController::class, 'index'])->name('profile');
Route::get('profile/edit', [ProfileController::class, 'edit'])->name('profile.edit');
Route::post('profile', [ProfileController::class, 'update'])->name('profile.update');

/*
 * Role CRUD routes group
 */
Route::resource('roles', RoleController::class)->except('show');
Route::get('roles/{role}/delete', [RoleController::class, 'delete'])->name('roles.delete');

/*
 * Permission CRUD routes group
 */
Route::resource('permissions', PermissionController::class)->except('show');
Route::get('permissions/{permission}/delete', [PermissionController::class, 'delete'])
    ->name('permissions.delete');

/*
 * Auth routes group
 */
Route::get('login', [App\Http\Controllers\Auth\LoginController::class, 'showLoginForm'])->name('login');
Route::post('login', [App\Http\Controllers\Auth\LoginController::class, 'login']);
Route::get('logout', [App\Http\Controllers\Auth\LoginController::class, 'logout'])->name('logout');

app/Models/Profile.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

/**
 * Class Profile
 *
 * @mixin Builder
 */
class Profile extends Model
{
    use HasFactory;

    /**
     * The database table used by the model.
     *
     * @var string
     */
    protected $table = 'profiles';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'user_id',
        'image',
    ];

    /**
     * Relation to profile's User
     *
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/ProfileController.php
<?php

namespace App\Http\Controllers;

use App\Models\Profile;
use App\Jobs\ProcessImageUpload;
use App\Models\User;
use App\Services\ImageProcessor;
use Illuminate\Http\Request;

class ProfileController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show user profile.
     *
     */
    public function index()
    {
        $user = User::find(auth()->id());

        $profile = null;

        if ($user->hasProfile()) {
            $profile = $user->profile()->first();

            $image = $profile['image'];

            $imageConverted = ImageProcessor::getConvertedImage($image, '320x320');

            if (ImageProcessor::hasImage($imageConverted)) {
                $profile['image'] = $imageConverted;
            }
        }

        return view('admin.profile.index', [
            'user' => $user,
            'profile' => $profile
        ]);
    }

    /**
     * Show the form for editing profile.
     *
     */
    public function edit()
    {
        return view('admin.profile.create');
    }

    /**
     * Update or create new profile in storage.
     *
     */
    public function update(Request $request)
    {
        $request->validate([
            'image' => 'required|image|mimes:jpeg,png,jpg|max:10240'
        ]);

        $userId = auth()->id();

        $filePath = $request->file('image')->store('/', ['disk' => 'uploads']);

        $profile = Profile::updateOrCreate(['user_id' => $userId], ['image' => $filePath]);

        ProcessImageUpload::dispatch($profile);

        return redirect()->route('profile')->with(['status' => 'Profile updated successfully.']);
    }
}

resources/views/admin/profile/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="box-container container">
        <h1>Create Profile</h1>
        {{ Form::open(['route' => 'profile.update', 'files' => true]) }}

        <div class="form-group">
            {!! Form::label('image', 'Image') !!}
            {!! Form::file('image', ['class' => 'form-control-file', 'required']) !!}
        </div>
        {!! Form::submit('Create', ['class' => 'btn btn-success']) !!}
        {!! link_to_route('home', 'Back', [], ['class' => 'btn btn-secondary']) !!}
        {!! Form::close() !!}
    </div>
@endsection

resources/views/admin/profile/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="box-container">
            <div class="row head justify-content-center">
                <h1>{{ __('Profile') }}</h1>
            </div>
            <div class="profile">
                <div class="col">
                    <div class="row profile-name justify-content-center">
                        <h3><strong>{{ $user->name }}</strong></h3>
                    </div>
                    <div class="row justify-content-center">
                        <div class="profile-image">
                            @if ( $profile && $profile['image'])
                                <img src="{{ asset(('storage/uploads/' . $profile['image'])) }}" alt="image">
                            @else
                                <img src="{{ asset('images/default_profile.jpg') }}" alt="image">
                            @endif
                        </div>
                    </div>
                    <div class="row justify-content-center profile-buttons">
                        <a href="{!! route('users.edit', $user) !!}" class="btn btn-action">{{ __('Edit Account') }}</a>
                        <a href="{!! route('profile.edit') !!}" class="btn btn-action">{{ __('Edit Profile') }}</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection